var slidersList = [
    {name: 'square', max: 10000},
    {name: 'bedroom', max: 10},
    {name: 'bathroom', max: 10},
    {name: 'rooms', max: 30},
    {name: 'pets', max: 20}];
var page = 1;

$(document).ready(function() {
    initSliders();
    openPage(page);

    $('.form-icon-item').on('click', function() {
        var checkbox = $(this).find('input');
        var value = !checkbox.prop('checked');
        checkbox.prop('checked', value);
        $(this).toggleClass('selected');
    });

    $('.form-expand-fields-button').on('click', function(e) {
        e.preventDefault();
        $(this).addClass('form-hide');
        $('.form-additional-fields').removeClass('form-hide');
    });

    $('.form-next-button, .form-submit-button').on('click', function(e){
        e.preventDefault();
        navigate(1);
    });

    $('.form-previous-button').on('click', function(e){
        e.preventDefault();
        navigate(-1);
    });
});

function initSliders() {
    slidersList.forEach(function(slide) {
        var handle = $( '#custom-handle-'+slide.name );
        $('#form-slider-'+slide.name).slider({
            create: function() {
                handle.text( $( this ).slider( "value" ) );
            },
            slide: function( event, ui ) {
                handle.text( ui.value );
                $('#range-'+slide.name).val(ui.value);
                ui.value > 99 ? $('#form-slider-'+slide.name).addClass('ui-slider-overflow') :
                $('#form-slider-'+slide.name).removeClass('ui-slider-overflow');
            },
            min: 0,
            max: slide.max
        });
    });
}

function openPage(page) {
    $('.form-page, .form-footer-button-set').addClass('form-hide');
    $('.form-page-'+page).removeClass('form-hide');
    $('.form-footer-button-set-'+page).removeClass('form-hide');
}

function navigate(direction) {
    var newPage = page + direction;
    const max = 3;
    if (direction === -1 && newPage < 0) {
        newPage = max;
    }
    if (direction === 1 && newPage > max) {
        newPage = 0;
    }
    page = Math.min(Math.max(newPage, 0), max);
    openPage(page);
}
